import logging
import WebFrame as WF
from WebFrame import handler
from WebFrame import template
from WebFrame import cache

# Limit cache to test out LRU.
# You should put something larger here, or leave it as default.
WF.set_opt("cache.entries", 2)


# Cache test handlers
def cache_get(ctx):
    ctx.resp.write("Query: %s\n" % str(ctx.req.params["key"]))
    if cache.has("app", str(ctx.req.params["key"])):
        ctx.resp.write(str(cache.get("app", ctx.req.params["key"]))+"\n")
    else:
        ctx.resp.write("Not found\n")
    return ctx.resp.stop_processing()
handler.register_plain("ANY", "/cache/get", ".*", cache_get,
                       "@public", "@public")
####
def cache_set(ctx):
    ctx.resp.write("Key: %s\n" % str(ctx.req.params["key"]))
    ctx.resp.write("Value: %s\n" % str(ctx.req.params["value"]))
    cache.set("app", str(ctx.req.params["key"]), str(ctx.req.params["value"]))
    return ctx.resp.stop_processing()
handler.register_plain("ANY", "/cache/set", ".*", cache_set,
                       "@public", "@public")
####
